#include "StdAfx.h"
#include "ShThrd.h"
#include "Structs.h"
#include "Utils.h"
#include "WndHlp.h"

#include "resource.h"

#define UNICODE 1

#ifdef _DEBUG
#pragma warning(disable:4133)
#endif
unsigned int __stdcall 
FillShareList(LPVOID lpParam)
{
	LPSHAREINFO pshi = (LPSHAREINFO)lpParam;

	HMODULE _hNetApi32 = 0;

	NETSHAREENUMPROC		lpfnNetShareEnum		= 0;
	NETAPIBUFFERFREEPROC	lpfnNetApiBufferFree	= 0;
	NETCONNECTIONENUMPROC	lpfnNetConnectionEnum	= 0;
	NETFILEENUMPROC			lpfnNetFileEnum			= 0;

	TCHAR
			lpszShareName[_MAX_PATH + 1],
			lpszConnName[_MAX_PATH + 1],
			lpszFileName[_MAX_PATH + 1];

	TCHAR lpszNetApi32Dll[_MAX_PATH + 1];
	char  lpszNetShareEnum[_MAX_PATH + 1];
	char  lpszNetConnectionEnum[_MAX_PATH + 1];
	char  lpszNetFileEnum[_MAX_PATH + 1];
	char  lpszNetApiBufferFree[_MAX_PATH + 1];
	TCHAR lpszData[_MAX_PATH + 1];

	PSHARE_INFO_502		pBuffer		= 0;
	PCONNECTION_INFO_1	pConInfo1	= 0;
	PFILE_INFO_3		pFileInfo3	= 0;

	LPTREESHARENODEINFO	pConInfoData= 0;

	DWORD dwEntriesRead  = 0;
	DWORD dwTotalEntries = 0;
	DWORD dwResumeHandle = 0;

	NET_API_STATUS nas			= 0;
	NET_API_STATUS nas2			= 0;
	NET_API_STATUS nas3			= 0;

	DWORD dwConnEntriesRead		= 0;
	DWORD dwConnTotalEntries	= 0; 
	DWORD dwConnResumeHandle	= 0;

	DWORD dwFileEntriesRead		= 0;
	DWORD dwFileTotalEntries	= 0;
	DWORD dwFileResumeHandle	= 0;
	
	register DWORD x, y, z;

	TVINSERTSTRUCT tvInsS, tvInsC, tvInsF;
	TVITEMEX tvItemExS, tvItemExC, tvItemExF;
	HTREEITEM hRoot = 0, hConnParent = 0, hFileParent = 0;

	HANDLE harrEvents[2];
	DWORD  dwWait = 0;

	harrEvents[0] = pshi->hCancelEvent;
	harrEvents[1] = pshi->hCloseEvent;

	dwWait = WaitForMultipleObjects(2, harrEvents, FALSE, 0);

	tvItemExS.mask				= TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
	tvItemExS.pszText			= lpszShareName;
	tvItemExS.cchTextMax		= _MAX_PATH + 1;
	tvItemExS.iImage			= 1;
	tvItemExS.iSelectedImage	= 1;
	tvItemExS.lParam			= 0;

	tvInsS.hParent		= 0;
	tvInsS.hInsertAfter	= 0;
	tvInsS.itemex		= tvItemExS;

	//	job
	pshi = (LPSHAREINFO)lpParam;
	
	if( !LoadStringA(AfxGetApp()->m_hInstance, IDS_NETSHAREENUM		, lpszNetShareEnum, _MAX_PATH + 1)		|| 
		!LoadStringA(AfxGetApp()->m_hInstance, IDS_NETAPIBUFFERFREE	, lpszNetApiBufferFree, _MAX_PATH + 1)	|| 
		!LoadStringA(AfxGetApp()->m_hInstance, IDS_NETAPI32DLL		, lpszNetApi32Dll, _MAX_PATH + 1)		||
		!LoadStringA(AfxGetApp()->m_hInstance, IDS_NETCONNECTIONENUM, lpszNetConnectionEnum, _MAX_PATH + 1) ||
		!LoadStringA(AfxGetApp()->m_hInstance, IDS_NETFILEENUM		, lpszNetFileEnum, _MAX_PATH + 1))
		goto _cleanup_;

	_stprintf(lpszShareName, _T("%s"), pshi->lpszMachineName);
	hRoot = TreeView_InsertItem(pshi->hwndTV, &tvInsS);

	tvInsS.hParent = hRoot;

	_hNetApi32 = LoadLibrary(lpszNetApi32Dll);
	if(_hNetApi32)
	{
		lpfnNetShareEnum		= (NETSHAREENUMPROC)GetProcAddress(_hNetApi32, lpszNetShareEnum);
		lpfnNetApiBufferFree	= (NETAPIBUFFERFREEPROC)GetProcAddress(_hNetApi32, lpszNetApiBufferFree);
		lpfnNetConnectionEnum	= (NETCONNECTIONENUMPROC)GetProcAddress(_hNetApi32, lpszNetConnectionEnum);
		lpfnNetFileEnum			= (NETFILEENUMPROC)GetProcAddress(_hNetApi32, lpszNetFileEnum);

		if(lpfnNetShareEnum && lpfnNetApiBufferFree && lpfnNetConnectionEnum && lpfnNetFileEnum)
		{
			do
			{
				//	WaitForMultipleObject (cancel & close)
				dwWait = WaitForMultipleObjects(2, harrEvents, FALSE, 0);
				if((dwWait >= WAIT_OBJECT_0) && (dwWait <= (WAIT_OBJECT_0 + 2 - 1)))
				{
					if(dwWait == WAIT_OBJECT_0)			// cancel	--> close
						goto _cleanup_;
					else if(dwWait == WAIT_OBJECT_0 + 1) // close
						goto _cleanup_;
				}

				nas = 
					(*lpfnNetShareEnum)
						(
							_WCSTR(pshi->lpszMachineName), 
							502, 
							(LPBYTE *)&pBuffer, 
							MAX_PREFERRED_LENGTH, 
							&dwEntriesRead, 
							&dwTotalEntries, 
							&dwResumeHandle 
						);

				if((nas == ERROR_SUCCESS) || (nas == ERROR_MORE_DATA))
				{
					for(x = 0; x < dwEntriesRead; x++)
					{
						_tcscpy(lpszShareName, _MBSTR((LPCWSTR)pBuffer[x].shi502_netname));

						tvItemExS.iImage		 = pBuffer[x].shi502_type & STYPE_IPC ? 8 : 0;
						tvItemExS.iSelectedImage = pBuffer[x].shi502_type & STYPE_IPC ? 8 : 0;

						tvInsS.itemex			= tvItemExS;
						hConnParent = TreeView_InsertItem(pshi->hwndTV, &tvInsS);

						if(x == 0)
							TreeView_Expand(pshi->hwndTV, hRoot, TVE_EXPAND);

						if(pBuffer[x].shi502_current_uses > 0 && hConnParent)
						{
							dwConnResumeHandle = 0;

							//	enum connections
							do
							{
								nas2 = 
									(*lpfnNetConnectionEnum)
										(
											_WCSTR(pshi->lpszMachineName), 
											_WCSTR(lpszShareName), 
											1, 
											(LPBYTE *)&pConInfo1,
											MAX_PREFERRED_LENGTH, 
											&dwConnEntriesRead, 
											&dwConnTotalEntries, 
											&dwConnResumeHandle
										);

								if((nas2 == ERROR_SUCCESS) || (nas2 == ERROR_MORE_DATA))
								{
									for(y = 0; y < dwConnEntriesRead; y++)
									{
										_tcscpy(lpszConnName, _MBSTR((LPCWSTR)pConInfo1[y].coni1_netname));

										_stprintf(lpszData, _T("%S from %s"), 
											pConInfo1[y].coni1_username ? pConInfo1[y].coni1_username : _T(""),
											lpszConnName);

										pConInfoData = new TREESHARENODEINFO;
										if(pConInfoData)
										{
											pConInfoData->cbSize			= sizeof(TREESHARENODEINFO);
											pConInfoData->dwConnId			= pConInfo1[y].coni1_id;
											pConInfoData->dwConnType		= pConInfo1[y].coni1_type;
											pConInfoData->dwConnNumOpens	= pConInfo1[y].coni1_num_opens;
											pConInfoData->dwConnNumUsers	= pConInfo1[y].coni1_num_users;
											pConInfoData->dwConnTime		= pConInfo1[y].coni1_time;

											if(pConInfo1[y].coni1_username)
												wcscpy(pConInfoData->lpszUserName, (LPWSTR)pConInfo1[y].coni1_username);
											else
												wcscpy(pConInfoData->lpszUserName, L"");

											if(pConInfoData->lpszNetName)
												wcscpy(pConInfoData->lpszNetName, (LPWSTR)pConInfo1[y].coni1_netname);
											else
												wcscpy(pConInfoData->lpszNetName, L"");
										}

										tvItemExC.mask				= TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
										tvItemExC.pszText			= lpszData;
										tvItemExC.cchTextMax		= (_tcslen(lpszData) + 1) * sizeof(TCHAR);
										tvItemExC.iImage			= 7;
										tvItemExC.iSelectedImage	= 7;
										tvItemExC.lParam			= (LPARAM)pConInfoData;

										tvInsC.itemex			= tvItemExC;
										tvInsC.hParent			= hConnParent;

										hFileParent = TreeView_InsertItem(pshi->hwndTV, &tvInsC);

										if((pConInfo1[y].coni1_num_opens > 0) && hFileParent)
										{
											dwFileResumeHandle = 0;

											do
											{
												nas3 = 
													(*lpfnNetFileEnum)
														(
															_WCSTR(pshi->lpszMachineName),
															0, //_WCSTR(lpszShareName),
															(LPWSTR)pConInfo1[y].coni1_username,
															3,
															(LPBYTE*)&pFileInfo3,
															MAX_PREFERRED_LENGTH,
															&dwFileEntriesRead,
															&dwFileTotalEntries,
															&dwFileResumeHandle
														);

												if((nas3 == ERROR_SUCCESS) || (nas3 == ERROR_MORE_DATA))
												{
													for(z = 0; z < dwFileEntriesRead; z++)
													{
														int nFileImage;
														GetFileImage(pFileInfo3->fi3_permissions, &nFileImage);

														_tcscpy(lpszFileName, _MBSTR((LPCWSTR)pFileInfo3[z].fi3_pathname));

														tvItemExF.mask				= TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_PARAM;
														tvItemExF.pszText			= lpszFileName;
														tvItemExF.cchTextMax		= (_tcslen(lpszFileName) + 1) * sizeof(TCHAR);
														tvItemExF.iImage			= nFileImage;
														tvItemExF.iSelectedImage	= nFileImage;
														tvItemExF.lParam			= (LPARAM)pFileInfo3[z].fi3_id; // keep ID for subsequent calls

														tvInsF.itemex			= tvItemExF;
														tvInsF.hParent			= hFileParent;

														TreeView_InsertItem(pshi->hwndTV, &tvInsF);
													}
												}

												(*lpfnNetApiBufferFree)(pFileInfo3);

											} while(nas3 == ERROR_MORE_DATA);
										}
									}
								}

								(*lpfnNetApiBufferFree)(pConInfo1);

							} while(nas2 == ERROR_MORE_DATA);
						}
					}
				}

				(*lpfnNetApiBufferFree)(pBuffer);

			} while(nas == ERROR_MORE_DATA);
		}

		FreeLibrary(_hNetApi32);
	}

	goto _cleanup_;

_cleanup_:
	
	if(pshi->hCancelEvent)
		CloseHandle(pshi->hCancelEvent);
	if(pshi->hCloseEvent)
		CloseHandle(pshi->hCloseEvent);

	delete pshi;

	return 0;
}
